/* 
		This is Database Functions header file 


03-15-2003	Merging of 4.0.10 and 4.3beta

		-------------------------------------------------------------
		Andrew Young (baram01@hotmail.com)
*/

#if defined(USE_DB)

#ifndef _TAC_DB_H_		/* to avoid duplicate definitions */
#define _TAC_DB_H_

/* The databases  recognized by this definition */
#define DEFINED_DB {"null","mysql","odbc","pgsql"}

#define SQLCMDL 2048

#define AUTHSQL "SELECT %s, gid, disable, auth FROM %s WHERE %s=\"%s\" and (UNIX_TIMESTAMP(expires)>UNIX_TIMESTAMP() or expires='0000-00-00 00:00:00')"
#define HOSTAUTHSQL "SELECT %s, hostgroup FROM host WHERE network=(%u&submask) and host=1 ORDER BY submask DESC"
#define HOSTGROUPSQL "SELECT %s FROM host WHERE ip=\"%s\""
#define USERACCESSSQL "SELECT permission FROM user, acl where acl_id=acl.id and uid in ('%s', '%s') and type=1 and value1=(INET_ATON('%s')&submask)"
#define HOSTACLSQL "SELECT %s, hostgroup, vendor FROM host WHERE network=(%u&submask) and host=1 ORDER BY submask DESC"
#define NASACLSQL "SELECT permission, value1 FROM acl WHERE id=%d AND value IN ('%s', '%s','allusers') AND type=2 ORDER BY seq"

#define ACCTSQL "INSERT INTO %s (date,nas,uid,terminal,client_ip,type,service,priv_lvl,elapsed_time,bytes_in,bytes_out,cmd) VALUES (NOW(),\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%s,%s,%s,%s,\"%s\")"
#define ACCESSSQL "INSERT INTO access (date,nas,terminal,uid,client_ip,service,status) VALUES (NOW(),\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")"

#if defined(DB_MYSQL)
#include <mysql.h>
typedef MYSQL DBH;
typedef MYSQL_ROW DB_ROW;
typedef MYSQL_RES DB_RES;
#endif

#if defined(DB_PGSQL)
#include <libpq-fe.h>
#define PWLEN   13
typedef PGresult DB_RES;
typedef struct {
	Gconn *conn;
	DB_RES *res;
} DBH;
#endif

#define DEFAULT_DB_TABLE_NAME "user"
#define DEFAULT_DB_FIELD_NAME_USER   "uid"
#define DEFAULT_DB_FIELD_NAME_PASSWD "password" 
#define DEFAULT_DB_ACCT_TABLE_NAME "accounting"

struct tac_dbinfo {
	char	*type;
	char	*user;
	char	*password;
	char	*host;
	char	*database;		/* Database to use */
	char	*table;
	char	*field_name;
	char	*field_passwd;
};

typedef struct tac_dbinfo TAC_DBINFO;

struct author_user {
	int svc_dflt;
	int cmd_dflt;
	char username[30];
	char member[30];
	char pre_author[50];
	char post_author[50];
	tac_uint32 profile;
	int vid;  /** Vendor id for attributes to use **/
};

int db_connect(DBH *, TAC_DBINFO *);
void db_close(DBH *);
DB_RES *db_store_result(DBH *);
int db_num_rows(DB_RES *);
DB_ROW db_fetch_row(DB_RES *);
void db_free_result(DB_RES *);
int db_affected_rows(DBH *);
int db_get_host(char *, tac_uint32, char *, TAC_DBINFO *);
int db_access();
int db_author();
#endif 
#endif /* USE_DB */
