/*

		Writen by Devrim SERAL(devrim@gazi.edu.tr)
     This program writen for MySQL Authentication and Accounting Propose

License: This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later version.

*/

#include "tac_plus.h"

#if defined(DB_MYSQL) && defined(USE_DB)

#include <stdio.h>
#include <mysql.h>
#include "db.h"

#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif


int mysql_db_connect(mysqldb, dbinfo)
MYSQL *mysqldb;
TAC_DBINFO *dbinfo;
{
/* Connect to database server */

    if ( !mysql_init(mysqldb) )
	{
        if (debug & (DEBUG_AUTHEN_FLAG|DEBUG_ACCT_FLAG))
			report(LOG_DEBUG, "mysql_connect: cannot initialize");
		return(0);
	}

    if (!mysql_real_connect(mysqldb,dbinfo->host,dbinfo->user,dbinfo->password,dbinfo->database, 0, NULL, 0))
	{
		if (debug & (DEBUG_AUTHEN_FLAG|DEBUG_ACCT_FLAG))
			report(LOG_DEBUG, "mysql_connect: cannot connect as %s. Error: %s", dbinfo->user, mysql_error(mysqldb));
		return(0);
	}

	return (1);
}

#define MYSACCTSQL "INSERT INTO shell_acct (usern,server,client,port," \
				   " rectype,task_id,starttime,timezone," \
		           " elapsed_time,disc_cause,priv_lvl,cmd) " \
				   " VALUES (\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%s,%s,\"%s\",%s,%s,%s,\"%s\")"

int 
mysql_db_shell_acct(TAC_DBINFO *dbinfo, char *s_name, char *c_name, char *a_username, struct acct_rec *rec)
{
	int sql_len;
	MYSQL mysqldb;
	char mysqlcmd[SQLCMDL];
	char *pCmdFormat = MYSACCTSQL;

	char *pArg_cmd;
	char *pArg_timezone;
	char *pArg_elapsed_time;
	char *pArg_disc_cause;
	char *pArg_priv_lvl;
	char *pArg_port;
	char *pArg_rectype;
	char *pArg_task_id;
	char *pArg_starttime;
	char *pUnknown = "unknown";
	char *pDBNULL = "NULL";
	
	if (debug & DEBUG_ACCT_FLAG)
		report(LOG_DEBUG, "MySQL: write shell accounting record");

/* Connect database server */
	if (!mysql_db_connect(&mysqldb, dbinfo)) {
		return(0);
	}

/* Prepare variables for select string */

	if(NULL == (pArg_cmd = find_attr_value("cmd", rec->args, rec->num_args))) {
		pArg_cmd = "";
	}
	/* edit the cmd field to remove the <cr> sometimes appended to the message */
	if (*pArg_cmd) {
		char *pTmp = (char *)strstr( pArg_cmd, "<cr>");
		if (pTmp) {
			*pTmp = '\0';
		}
	}

	if(NULL == (pArg_timezone = find_attr_value("timezone", rec->args, rec->num_args))) {
		pArg_timezone = "";
	}
	if(NULL == (pArg_priv_lvl = find_attr_value("priv-lvl", rec->args, rec->num_args))) {
		pArg_priv_lvl = pDBNULL;
	}
	if(NULL == (pArg_starttime = find_attr_value("start_time", rec->args, rec->num_args))) {
		pArg_starttime = "0";
	}
	if(NULL == (pArg_task_id = find_attr_value("task_id", rec->args, rec->num_args))) {
		pArg_task_id = "0";
	}
	if(NULL == (pArg_elapsed_time = find_attr_value("elapsed_time", rec->args, rec->num_args))) {
		pArg_elapsed_time = pDBNULL;
	}

	if(NULL == (pArg_disc_cause = find_attr_value("disc-cause-ext", rec->args, rec->num_args))) {
		if(NULL == (pArg_disc_cause = find_attr_value("disc-cause", rec->args, rec->num_args))) {
			pArg_disc_cause = pDBNULL;
		}
	}

	if (NULL == (pArg_port = rec->identity->NAS_port)) {
		pArg_port = pUnknown;
	}

    switch(rec->acct_type) {
		case ACCT_TYPE_UPDATE:
			pArg_rectype = "upd";
			break;
		case ACCT_TYPE_START:
			pArg_rectype = "start";
			break;
		case ACCT_TYPE_STOP:
			pArg_rectype = "stop";
			break;
		default:
			pArg_rectype = pUnknown;
			break;
    }

/* Check buffer overflow for select string */

	sql_len=strlen(dbinfo->table)+strlen(a_username)+
		strlen(s_name)+strlen(c_name)+
		strlen(pArg_port)+strlen(pArg_rectype)+strlen(pArg_starttime)+strlen(pArg_timezone)+
		strlen(pArg_elapsed_time)+strlen(pArg_disc_cause)+strlen(pArg_priv_lvl)+
		strlen(pArg_cmd)+strlen(pArg_task_id)+
		strlen(pCmdFormat);  

	if (debug & DEBUG_ACCT_FLAG)
		report(LOG_DEBUG, "MySQL: Length of Sql command: %d", sql_len);


	if ( sql_len >= SQLCMDL ) {
        if (debug & DEBUG_ACCT_FLAG)
			report(LOG_DEBUG, "MySQL: Sql cmd greater than allowed limit of %d", SQLCMDL);
       	return(0);
	}

	sprintf(mysqlcmd, pCmdFormat, 
		a_username,s_name,c_name,pArg_port, pArg_rectype, pArg_task_id, pArg_starttime, pArg_timezone,
		pArg_elapsed_time, pArg_disc_cause, pArg_priv_lvl, pArg_cmd);

	if (debug & DEBUG_ACCT_FLAG)
		report(LOG_DEBUG, "MySQL: %s ", mysqlcmd);

/*  Query database */

	if (mysql_query(&mysqldb,mysqlcmd)) {
		if (debug & DEBUG_ACCT_FLAG)
			report(LOG_DEBUG, "MySQL: Error %d, %s", mysql_errno(&mysqldb), mysql_error(&mysqldb));
		return(0);
	}

/* Check if accounting is sucess */
    if ( mysql_affected_rows( &mysqldb ) < 0 ) {
		if (debug & DEBUG_ACCT_FLAG)
			report(LOG_DEBUG, "MySQL: Insert isn't sucess");
        return(0);
    }
	return (1); /* Return 1 if verified, 0 otherwise. */
}

/* end of MySQL Shell accounting */

#endif
