use tacacs;

DELETE FROM acl WHERE id=0;

ALTER TABLE attribute DROP PRIMARY KEY,
		      ADD encrypt INT(1) DEFAULT 0 AFTER auth,
		      ADD has_tag INT(1) DEFAULT 0 AFTER auth,
		      ADD PRIMARY KEY (id, vid, auth);

CREATE TABLE attribute ( id INT NOT NULL, name VARCHAR(30),
        descr VARCHAR(255), type INT(1) NOT NULL, auth INT(1) NOT NULL,
	has_tag INT(1) DEFAULT 0, encrypt INT(1) DEFAULT 0,
        disp_len INT DEFAULT 0, vid INT(5) NOT NULL,
        PRIMARY KEY (id, vid, auth) );

INSERT INTO attribute VALUES (300, 'priv-lvl', 'Priviledge Level', 1, 0, NULL,
NULL, NULL, 9);
INSERT INTO attribute VALUES (300, 'priv-lvl', 'Priviledge Level', 1, 0, NULL,
NULL, NULL, 1916);
INSERT INTO attribute VALUES (300, 'foundry-privlvl', 'Priviledge Level', 1, 0, NULL, NULL, NULL, 1991);
INSERT INTO attribute VALUES (300, 'junos-exec', 'Juniper Exec Service', 0, 0,
NULL, NULL, NULL, 2636);

CREATE TABLE vendor ( id INT(5) NOT NULL, name VARCHAR(30),
	PRIMARY KEY (id) );
 
INSERT INTO vendor VALUES ( 0, 'None' );
INSERT INTO vendor VALUES ( 9, 'Cisco' );
INSERT INTO vendor VALUES ( 52, 'Cabletron/Enterasys' );
INSERT INTO vendor VALUES ( 166, 'Shiva' );
INSERT INTO vendor VALUES ( 307, 'Livingston' );
INSERT INTO vendor VALUES ( 311, 'Microsoft' );
INSERT INTO vendor VALUES ( 429, 'Usr' );
INSERT INTO vendor VALUES ( 529, 'Ascend');
INSERT INTO vendor VALUES ( 1584, 'Bay-Networks' );
INSERT INTO vendor VALUES ( 1916, 'Extreme-Networks' );
INSERT INTO vendor VALUES ( 1991, 'Foundry-Networks' );
INSERT INTO vendor VALUES ( 2180, 'Versanet' );
INSERT INTO vendor VALUES ( 2352, 'Redback' );
INSERT INTO vendor VALUES ( 2636, 'Juniper' );
INSERT INTO vendor VALUES ( 3551, 'SprindTide' );
INSERT INTO vendor VALUES ( 4874, 'ERX' );
INSERT INTO vendor VALUES ( 8246, 'Cistron' );
 
ALTER TABLE host ADD hostgroup varchar(16) AFTER ip, ADD host INT(1), ADD vendor int(5) default 0;
ALTER TABLE host DROP INDEX net (network), DROP INDEX sub (submask),
		 ADD INDEX net (network, submask);
UPDATE host set host=1;

ALTER TABLE user DROP gpassword, ADD auth INT(1) AFTER comment, ADD disable INT(1) NOT NULL DEFAULT 0 AFTER expires;
ALTER TABLE user DROP PRIMARY KEY, DROP profile,
		 ALTER auth SET DEFAULT 1,
		 ADD id REAL NOT NULL PRIMARY KEY AUTO_INCREMENT FIRST,
		 ADD groupid REAL NOT NULL DEFAULT 65534 AFTER gid,
		 ADD shell VARCHAR(20), ADD homedir VARCHAR(50), 
		 ADD UNIQUE uid(uid);
UPDATE user set auth=1;

ALTER TABLE node ADD attr INT, ADD vid INT(5), ADD INDEX uid(uid), DROP INDEX service, DROP INDEX command;
ALTER TABLE node DROP PRIMARY KEY,
		 ADD id REAL NOT NULL FIRST,
		 ADD INDEX id (id), ADD INDEX uid (uid);

UPDATE acl set value1=0 WHERE type=2;

#ONLY WORKS IN 4.0 and above
UPDATE node, user SET node.id = user.id WHERE node.uid=user.uid;
