use tacacs;

DELETE FROM acl WHERE id=0;

CREATE TABLE attribute ( id INT NOT NULL, name VARCHAR(30),
        descr VARCHAR(255), type INT(1) NOT NULL, auth INT(1) NOT NULL,
        has_tag INT(1) DEFAULT 0, encrypt INT(1) DEFAULT 0,
        disp_len INT DEFAULT 0, vid INT(5) NOT NULL,
        PRIMARY KEY (id, vid, auth) );

INSERT INTO attribute VALUES (300, 'priv-lvl', 'Priviledge Level', 1, 0, NULL,
NULL, NULL, 9);
INSERT INTO attribute VALUES (300, 'priv-lvl', 'Priviledge Level', 1, 0, NULL,
NULL, NULL, 1916);
INSERT INTO attribute VALUES (300, 'foundry-privlvl', 'Priviledge Level', 1, 0, NULL, NULL, NULL, 1991);
INSERT INTO attribute VALUES (300, 'junos-exec', 'Juniper Exec Service', 0, 0,
NULL, NULL, NULL, 2636);

CREATE TABLE vendor ( id INT(5) NOT NULL, name VARCHAR(30),
	PRIMARY KEY (id) );
 
INSERT INTO vendor VALUES ( 0, 'None' );
INSERT INTO vendor VALUES ( 9, 'Cisco' );
INSERT INTO vendor VALUES ( 52, 'Cabletron/Enterasys' );
INSERT INTO vendor VALUES ( 166, 'Shiva' );
INSERT INTO vendor VALUES ( 307, 'Livingston' );
INSERT INTO vendor VALUES ( 311, 'Microsoft' );
INSERT INTO vendor VALUES ( 429, 'Usr' );
INSERT INTO vendor VALUES ( 529, 'Ascend');
INSERT INTO vendor VALUES ( 1584, 'Bay-Networks' );
INSERT INTO vendor VALUES ( 1916, 'Extreme-Networks' );
INSERT INTO vendor VALUES ( 1991, 'Foundry-Networks' );
INSERT INTO vendor VALUES ( 2180, 'Versanet' );
INSERT INTO vendor VALUES ( 2352, 'Redback' );
INSERT INTO vendor VALUES ( 2636, 'Juniper' );
INSERT INTO vendor VALUES ( 3551, 'SprindTide' );
INSERT INTO vendor VALUES ( 4874, 'ERX' );
INSERT INTO vendor VALUES ( 8246, 'Cistron' );
 
ALTER TABLE host ADD hostgroup varchar(16) AFTER ip, ADD host INT(1), ADD vendor int(5) default 0;
UPDATE host set host=1;

ALTER TABLE user DROP gpassword, ADD auth INT(1) AFTER comment, ADD disable INT(1) NOT NULL DEFAULT 0 AFTER expires;
UPDATE user set auth=1;

ALTER TABLE node ADD attr INT, ADD vid INT(5), ADD INDEX uid(uid), DROP INDEX service, DROP INDEX command;

CREATE TABLE profile ( id REAL NOT NULL PRIMARY KEY, name varchar(20) NOT NULL,INDEX id(id) );
